| Home | Libraries | People | FAQ | More

#### segments_encoded_view

A view representing path segments in a URL.

##### Synopsis

Defined in header `<boost/url/segments_encoded_view.hpp>`

    class segments_encoded_view :
        public segments_encoded_base

##### Types

Name | Description
--- | ---
const_iterator | A Bidirectional iterator to a path segment.
const_reference | The reference type.
difference_type | A signed integer type used to represent differences.
iterator | A Bidirectional iterator to a path segment.
reference | The reference type.
size_type | An unsigned integer type used to represent size.
value_type | The value type.

##### Member Functions

Name | Description
--- | ---
back | Return the last segment.
begin | Return an iterator to the beginning.
buffer | Return the referenced character buffer.
empty | Return true if there are no segments.
end | Return an iterator to the end.
front | Return the first segment.
is_absolute | Returns true if this references an absolute path.
operator= | Assignment.
operator segments_view | Conversion.
segments_encoded_view [constructor] | Constructor.
size | Return the number of segments.

##### Static Member Functions

Name | Description
--- | ---
max_size | Return the maximum number of characters possible.

##### Friends

Name | Description
--- | ---
parse_path | Parse a string and return an encoded segment view.

##### Description

Objects of this type are used to interpret the path as a bidirectional view of segment strings. The view does not retain ownership of the elements and instead references the original character buffer. The caller is responsible for ensuring that the lifetime of the buffer extends until it is no longer referenced.

##### Example

    url_view u( "/path/to/file.txt" );

    segments_encoded_view ps = u.encoded_segments();

    assert( ps.buffer().data() == u.buffer().data() );

Strings produced when elements are returned have type `param_pct_view` and represent encoded strings. Strings passed to member functions may contain percent escapes, and throw exceptions on invalid inputs.

##### Iterator Invalidation

Changes to the underlying character buffer can invalidate iterators which reference it.

##### See Also

`segments_view`, `segments_encoded_ref`, `segments_ref`.

Convenience header `<boost/url.hpp>`